<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00004005ParamFaturaContratoFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * A função "validaServicoRelacionado" verifica se o serviço 
     * que está sendo relacionado já existe está relacionadoao serviço.
     */
    public function insereDadosContrato($params){
        
        $queryInsereDadosContr = "UPDATE FCT_CONTRATO
                                    SET IDFATURACONTR = :IDFATURACONTR,
                                        CDMODPGTO = :CDMODPGTO,
                                        QTPARCELASFATU = :QTPARCELASFATU,
                                        NRDIAVENCPARCELASFATU = :NRDIAVENCPARCELASFATU,
                                        DTINICFATCONTR = :DTINICFATCONTR,
                                        IDQTDIASCOMPCON = :IDQTDIASCOMPCON,
                                        NRQTDIASCOMPCON = :NRQTDIASCOMPCON,
                                        IDTPCOMPETCONT = :IDTPCOMPETCONT,
                                        NRDIACOMPETCONT = :NRDIACOMPETCONT,
                                        IDTPDTEMISSNF = :IDTPDTEMISSNF,
                                        NRDIADTEMISSNF = :NRDIADTEMISSNF,
                                        IDTPDTVENC = :IDTPDTVENC,
                                        NRDIAVENPARCFAT = :NRDIAVENPARCFAT,
                                        IDTPFATUINCOMP = :IDTPFATUINCOMP
                                  WHERE NRSEQCONTRATO = :NRSEQCONTRATO
                                    AND NRORG = :NRORG";

        $std = $this->connection->prepare($queryInsereDadosContr);
        $std->execute($params);
    }
    
    
    public function getDadosModeloContrato(array $params) {
        $sql = "SELECT FCT_PARAMFATMODCONT.NRGRUPOFATURA, FCT_MODELOCONTRATO.IDTPCOMPETCONT, FCT_MODELOCONTRATO.NRDIACOMPETCONT, FCT_MODELOCONTRATO.NRDIAVENPARCFAT,
                       FCT_MODELOCONTRATO.IDTPDTEMISSNF, FCT_MODELOCONTRATO.NRDIADTEMISSNF, FCT_MODELOCONTRATO.IDTPDTVENC, FCT_MODELOCONTRATO.IDQTDIASCOMPCON, 
                       FCT_MODELOCONTRATO.NRQTDIASCOMPCON, FCT_MODELOCONTRATO.IDTPREAJUSTE, FCT_MODELOCONTRATO.IDTPMESREAJUSTE, FCT_MODELOCONTRATO.NRQTDREAJUSTE, 
                       FCT_MODELOCONTRATO.CDMODPGTO, FCT_MODELOCONTRATO.DTINICFATCONTR, FCT_MODELOCONTRATO.IDFATURACONTR, FCT_MODELOCONTRATO.IDTPFATUINCOMP, 
                       FCT_MODELOCONTRATO.QTPARCELASFATU, FCT_MODELOCONTRATO.NRDIAVENCPARCELASFATU,
                       NVL(FCT_PARAMFATMODCONT.IDSOMAFATUCONT, FCT_MODELOCONTRATO.IDSOMAFATUCONT) AS IDSOMAFATUCONT, 
                       FCT_PARAMFATMODCONT.IDSOMAITGRUPFAT, FCT_PARAMFATMODCONT.IDGERANFPARC, 
                       NVL(FCT_PARAMFATMODCONT.IDBLOQVRMEDIC, FCT_MODELOCONTRATO.IDBLOQVRMEDIC) AS IDBLOQVRMEDIC,
                       FCT_PARAMFATMODCONT.IDGERARATEIO, FCT_PARAMFATMODCONT.IDAPURAAPONTAMENTO 
                  FROM FCT_MODELOCONTRATO
                  LEFT JOIN FCT_PARAMFATMODCONT
                     ON FCT_PARAMFATMODCONT.NRSEQMODCONTRA = FCT_MODELOCONTRATO.NRSEQMODCONTRA
                    AND FCT_PARAMFATMODCONT.NRORG = FCT_MODELOCONTRATO.NRORG 
                  WHERE FCT_MODELOCONTRATO.NRSEQMODCONTRA = :NRSEQMODCONTRA
                    AND FCT_MODELOCONTRATO.NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    } 
}

?>